#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.TopLayout import TopLayout

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1361120743.489669
__CHEETAH_genTimestamp__ = 'Sun Feb 17 17:05:43 2013'
__CHEETAH_src__ = 'prewikka/templates/ClassicLayout.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Feb 23 16:14:18 2010'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class ClassicLayout(TopLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(ClassicLayout, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def body_class(self, **KWS):



        ## CHEETAH: generated from #def body_class() at line 3, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''classic_body
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def layout_start_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_start_hook at line 35, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def menu_extra_content(self, **KWS):



        ## CHEETAH: generated from #def menu_extra_content at line 53, col 3.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def layout_end_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_end_hook at line 60, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def toplayout_content(self, **KWS):



        ## CHEETAH: generated from #block toplayout_content at line 7, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_11212769 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
<div id="topmenu">
''')
        for name, link in VFFSL(SL,"interface.tabs",True): # generated from line 11, col 3
            if VFFSL(SL,"name",True) == VFFSL(SL,"interface.active_tab",True): # generated from line 12, col 5
                class_ = 'topmenu_item_active'
            else: # generated from line 14, col 5
                class_ = 'topmenu_item_inactive'
            write(u'''    <div class="''')
            _v = VFFSL(SL,"class_",True) # u'$class_' on line 17, col 17
            if _v is not None: write(_filter(_v, rawExpr=u'$class_')) # from line 17, col 17.
            write(u'''"><p><a href="''')
            _v = VFFSL(SL,"link",True) # u'$link' on line 17, col 38
            if _v is not None: write(_filter(_v, rawExpr=u'$link')) # from line 17, col 38.
            write(u'''">''')
            if False:
                _(VFFSL(SL,"name",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # u'$_($name)' on line 17, col 45
            if _v is not None: write(_filter(_v, rawExpr=u'$_($name)')) # from line 17, col 45.
            write(u'''</a></p></div>
''')
        write(u'''
  <div class="topmenu_item_special">
''')
        if VFFSL(SL,"prewikka.logout_link",True): # generated from line 21, col 3
            write(u'''    <p><a href="''')
            _v = VFFSL(SL,"prewikka.logout_link",True) # u'$prewikka.logout_link' on line 22, col 17
            if _v is not None: write(_filter(_v, rawExpr=u'$prewikka.logout_link')) # from line 22, col 17.
            write(u'''">''')
            if False:
                _("logout")
            _v = VFFSL(SL,"_",False)("logout") # u'$_("logout")' on line 22, col 40
            if _v is not None: write(_filter(_v, rawExpr=u'$_("logout")')) # from line 22, col 40.
            write(u'''</a></p>
''')
        write(u'''  </div>

  <div class="topmenu_item_info">
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_11212769
        write(u'''    <p>''')
        if False:
            _("%(username)s on %(date)s")
        _v = VFFSL(SL,"unicode",False)(VFFSL(SL,"_",False)("%(username)s on %(date)s") % { "username": VFFSL(SL,"prewikka.userlink",True), "date": VFFSL(SL,"prewikka.date",True) }) # u'$unicode($_("%(username)s on %(date)s") % { "username": $prewikka.userlink, "date": $prewikka.date })' on line 28, col 8
        if _v is not None: write(_filter(_v, rawExpr=u'$unicode($_("%(username)s on %(date)s") % { "username": $prewikka.userlink, "date": $prewikka.date })')) # from line 28, col 8.
        write(u'''</p>
''')
        _orig_filter_98565953 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''  </div>
</div>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_98565953
        _orig_filter_52218978 = _filter
        filterName = u'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
''')
        _v = VFFSL(SL,"layout_start_hook",True) # u'$layout_start_hook' on line 37, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'$layout_start_hook')) # from line 37, col 1.
        write(u'''

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_52218978
        _orig_filter_68375706 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''<div id="menu">
''')
        for name, link in VFFSL(SL,"interface.sections",True): # generated from line 42, col 3
            if VFFSL(SL,"name",True) == VFFSL(SL,"interface.active_section",True): # generated from line 43, col 5
                class_ = 'menu_item_active'
            else: # generated from line 45, col 5
                class_ = 'menu_item_inactive'
            write(u'''    <a class="''')
            _v = VFFSL(SL,"class_",True) # u'$class_' on line 48, col 15
            if _v is not None: write(_filter(_v, rawExpr=u'$class_')) # from line 48, col 15.
            write(u'''" href="''')
            _v = VFFSL(SL,"link",True) # u'$link' on line 48, col 30
            if _v is not None: write(_filter(_v, rawExpr=u'$link')) # from line 48, col 30.
            write(u'''">''')
            if False:
                _(VFFSL(SL,"name",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # u'$_($name)' on line 48, col 37
            if _v is not None: write(_filter(_v, rawExpr=u'$_($name)')) # from line 48, col 37.
            write(u'''</a>
''')
        write(u'''
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_68375706
        _orig_filter_12929381 = _filter
        filterName = u'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''  ''')
        _v = VFFSL(SL,"menu_extra_content",True) # u'$menu_extra_content' on line 55, col 3
        if _v is not None: write(_filter(_v, rawExpr=u'$menu_extra_content')) # from line 55, col 3.
        write(u'''
</div>

<div id="main">''')
        _v = VFFSL(SL,"main_content",True) # u'$main_content' on line 58, col 16
        if _v is not None: write(_filter(_v, rawExpr=u'$main_content')) # from line 58, col 16.
        write(u'''</div>

''')
        _v = VFFSL(SL,"layout_end_hook",True) # u'$layout_end_hook' on line 62, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'$layout_end_hook')) # from line 62, col 1.
        write(u'''

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_12929381
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''

''')
        self.toplayout_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_ClassicLayout= 'writeBody'

## END CLASS DEFINITION

if not hasattr(ClassicLayout, '_initCheetahAttributes'):
    templateAPIClass = getattr(ClassicLayout, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(ClassicLayout)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=ClassicLayout()).run()


