#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
import __builtin__
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.ClassicLayout import ClassicLayout
from prewikka import siteconfig

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.2.2'
__CHEETAH_versionTuple__ = (2, 2, 2, 'final', 0)
__CHEETAH_genTime__ = 1266916089.1082349
__CHEETAH_genTimestamp__ = 'Tue Feb 23 10:08:09 2010'
__CHEETAH_src__ = 'prewikka/templates/Database.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Feb 23 10:06:18 2010'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class Database(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(Database, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_90474992 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
<script type="text/javascript">
$(document).ready(function() {

  $("input[name=identifier]").change(function() {
        if ( "''')
        _v = VFFSL(SL,"identifier",True) # u'$identifier' on line 11, col 15
        if _v is not None: write(_filter(_v, rawExpr=u'$identifier')) # from line 11, col 15.
        write(u'''" && $(this).attr("value") == "''')
        _v = VFFSL(SL,"identifier",True) # u'$identifier' on line 11, col 58
        if _v is not None: write(_filter(_v, rawExpr=u'$identifier')) # from line 11, col 58.
        write(u'''" )
                $("input[name=save]").attr("value", "Update Database");
        else
                $("input[name=save]").attr("value", "Add Database");
  }).change();

  $("input[name=add]").click(function() {
        $("#dbsettings input[type!=submit]").each(function(i) {
                $(this).attr("value", "");
        });
        $("#dbsettings textarea").text("");
  });

  $("select").change(function() {
        if ( $(this).attr("value") == "sqlite3" ) {
                $("#dbsettings tr:not(.sqlite_only):not(.any_db)").hide()
                $("#dbsettings tr.sqlite_only:not(.any_db)").show()
        } else {
                $("#dbsettings tr:not(.sqlite_only)").show()
                $("#dbsettings tr.sqlite_only").hide()
        }
  }).change();
});
</script>

<div id="fieldset_page" style="width: 430px;">
<form action="?" method="post">

''')
        if VFFSL(SL,"dblist",True): # generated from line 39, col 1
            write(u'''<fieldset class="fieldset_heading">
<legend>Database Listing</legend>
<table>
 <tr>
  <th>Identifier</th>
  <th>Description</th>
  <th>Default</th>
  <th>Remove</th>
 </tr>
''')
            for id, desc, default, link in VFFSL(SL,"dblist",True): # generated from line 49, col 1
                write(u'''        <tr>
         <td><a href="''')
                _v = VFFSL(SL,"link",True) # u'$link' on line 51, col 23
                if _v is not None: write(_filter(_v, rawExpr=u'$link')) # from line 51, col 23.
                write(u'''">''')
                _v = VFFSL(SL,"id",True) # u'$id' on line 51, col 30
                if _v is not None: write(_filter(_v, rawExpr=u'$id')) # from line 51, col 30.
                write(u'''</a></td>
         <td>''')
                _v = VFFSL(SL,"desc",True) # u'$desc' on line 52, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$desc')) # from line 52, col 14.
                write(u'''</td>
''')
                if VFFSL(SL,"default",True) is True: # generated from line 53, col 1
                    write(u'''         <td><input type="radio" name="default" value="''')
                    _v = VFFSL(SL,"id",True) # u'$id' on line 54, col 56
                    if _v is not None: write(_filter(_v, rawExpr=u'$id')) # from line 54, col 56.
                    write(u'''" checked="checked" /></td>
''')
                else: # generated from line 55, col 1
                    write(u'''         <td><input type="radio" name="default" value="''')
                    _v = VFFSL(SL,"id",True) # u'$id' on line 56, col 56
                    if _v is not None: write(_filter(_v, rawExpr=u'$id')) # from line 56, col 56.
                    write(u'''" /></td>
''')
                write(u'''         <td><input type="checkbox" name="delete" value="''')
                _v = VFFSL(SL,"id",True) # u'$id' on line 58, col 58
                if _v is not None: write(_filter(_v, rawExpr=u'$id')) # from line 58, col 58.
                write(u'''" /></td>
        </tr>
''')
            write(u'''</table>

<br/><br/>

<input style="float:left;" type="button" name="add" value="Add Database" />
<input style="float:right;" type="submit" name="apply" value="Apply" />

</fieldset>
''')
        write(u'''
 <input type="hidden" name="view" value="database"/>

<fieldset id="dbsettings" class="fieldset_heading">
 <legend>Database Settings</legend>

 <table>
  <tr class="any_db">
   <th>Type</th>
   <td>
    <select name="type" style="width:126px;">
     <option value="mysql" ''')
        _v = VFFSL(SL,"mysql_selected",True) # u'$mysql_selected' on line 81, col 28
        if _v is not None: write(_filter(_v, rawExpr=u'$mysql_selected')) # from line 81, col 28.
        write(u'''>MySQL</option>
     <option value="pgsql" ''')
        _v = VFFSL(SL,"pgsql_selected",True) # u'$pgsql_selected' on line 82, col 28
        if _v is not None: write(_filter(_v, rawExpr=u'$pgsql_selected')) # from line 82, col 28.
        write(u'''>PostgreSQL</option>
     <option value="sqlite3" ''')
        _v = VFFSL(SL,"sqlite3_selected",True) # u'$sqlite3_selected' on line 83, col 30
        if _v is not None: write(_filter(_v, rawExpr=u'$sqlite3_selected')) # from line 83, col 30.
        write(u'''>SQLite 3</option>
    </select>
   </td>
  </tr>

  <tr>
   <th>Host</th>
   <td><input type="text" name="host" value="''')
        _v = VFFSL(SL,"host",True) # u'$host' on line 90, col 46
        if _v is not None: write(_filter(_v, rawExpr=u'$host')) # from line 90, col 46.
        write(u'''"/></td>
  </tr>

  <tr>
   <th>Port</th>
   <td><input type="text" name="port" value="''')
        _v = VFFSL(SL,"port",True) # u'$port' on line 95, col 46
        if _v is not None: write(_filter(_v, rawExpr=u'$port')) # from line 95, col 46.
        write(u'''"/></td>
  </tr>

  <tr>
   <th>Database</th>
   <td><input type="text" name="name" value="''')
        _v = VFFSL(SL,"name",True) # u'$name' on line 100, col 46
        if _v is not None: write(_filter(_v, rawExpr=u'$name')) # from line 100, col 46.
        write(u'''"/></td>
  </tr>

  <tr>
   <th>Username</th>
   <td><input type="text" name="user" value="''')
        _v = VFFSL(SL,"user",True) # u'$user' on line 105, col 46
        if _v is not None: write(_filter(_v, rawExpr=u'$user')) # from line 105, col 46.
        write(u'''" /></td>
  </tr>

  <tr>
   <th>Password</th>
   <td><input type="password" name="pass" value="''')
        _v = VFFSL(SL,"pass",True) # u'$pass' on line 110, col 50
        if _v is not None: write(_filter(_v, rawExpr=u'$pass')) # from line 110, col 50.
        write(u'''" /></td>
  </tr>

  <tr>
   <th>SQL logfile</th>
   <td><input type="text" name="log" value="''')
        _v = VFFSL(SL,"log",True) # u'$log' on line 115, col 45
        if _v is not None: write(_filter(_v, rawExpr=u'$log')) # from line 115, col 45.
        write(u'''" /></td>
  </tr>

''')
        if VFFSL(SL,"sqlite3_selected",True): # generated from line 118, col 1
            display = "";
        else: # generated from line 120, col 1
            display = "display: none";
        write(u'''
  <tr style="''')
        _v = VFFSL(SL,"display",True) # u'$display' on line 124, col 14
        if _v is not None: write(_filter(_v, rawExpr=u'$display')) # from line 124, col 14.
        write(u''';" class="sqlite_only">
   <th>File</th>
   <td><input type="text" name="file" value="''')
        _v = VFFSL(SL,"file",True) # u'$file' on line 126, col 46
        if _v is not None: write(_filter(_v, rawExpr=u'$file')) # from line 126, col 46.
        write(u'''"/></td>
  </tr>

  <tr class="any_db"><td colspan="2"><br/><i>Please enter an identifier and an optional description in order to identify this database:</i><br/></td></tr>

  <tr class="any_db">
   <th>Identifier</th>
   <td><input type="text" name="identifier" value="''')
        _v = VFFSL(SL,"identifier",True) # u'$identifier' on line 133, col 52
        if _v is not None: write(_filter(_v, rawExpr=u'$identifier')) # from line 133, col 52.
        write(u'''" /></td>
  </tr>

  <tr class="any_db">
   <th>Description</th>
   <td><textarea name="description" rows="4" cols="55">''')
        _v = VFFSL(SL,"description",True) # u'$description' on line 138, col 56
        if _v is not None: write(_filter(_v, rawExpr=u'$description')) # from line 138, col 56.
        write(u'''</textarea></td>
  </tr>
</table>

''')
        if VFFSL(SL,"error",True): # generated from line 142, col 2
            write(u'''  <div style="background-color: red;">''')
            _v = VFFSL(SL,"error",True) # u'$error' on line 143, col 39
            if _v is not None: write(_filter(_v, rawExpr=u'$error')) # from line 143, col 39.
            write(u'''</div>
''')
        write(u'''
 <input style="float:right;" type="submit" name="save" value="" />
</div>

</fieldset>

</form>

</div>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_90474992
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''
''')
        self.main_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_Database= 'writeBody'

## END CLASS DEFINITION

if not hasattr(Database, '_initCheetahAttributes'):
    templateAPIClass = getattr(Database, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(Database)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=Database()).run()


