#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.ClassicLayout import ClassicLayout

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1361120743.467364
__CHEETAH_genTimestamp__ = 'Sun Feb 17 17:05:43 2013'
__CHEETAH_src__ = 'prewikka/templates/MessageDetails.tmpl'
__CHEETAH_srcLastModified__ = 'Tue May  5 14:55:59 2009'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class MessageDetails(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(MessageDetails, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def display_node(self, node, **KWS):



        ## CHEETAH: generated from #def display_node($node) at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        display = ("block", "none")[VFFSL(SL,"node.hidden",True)]
        write(u'''<div class="message_details">
\t<div class="message_details_title"><a href="#" onclick="javascript:toggleVisibility(\'section_''')
        _v = VFFSL(SL,"node.id",True) # u'$node.id' on line 7, col 95
        if _v is not None: write(_filter(_v, rawExpr=u'$node.id')) # from line 7, col 95.
        write(u'''\'); return false;">''')
        _v = VFFSL(SL,"node.name",True) # u'$node.name' on line 7, col 122
        if _v is not None: write(_filter(_v, rawExpr=u'$node.name')) # from line 7, col 122.
        write(u'''</a></div>
\t<div class="message_details_content" id="section_''')
        _v = VFFSL(SL,"node.id",True) # u'$node.id' on line 8, col 51
        if _v is not None: write(_filter(_v, rawExpr=u'$node.id')) # from line 8, col 51.
        write(u'''" style="display: ''')
        _v = VFFSL(SL,"display",True) # u'$display' on line 8, col 77
        if _v is not None: write(_filter(_v, rawExpr=u'$display')) # from line 8, col 77.
        write(u'''">
''')
        for entry in VFFSL(SL,"node.entries",True): # generated from line 9, col 3
            if isinstance(VFFSL(SL,"entry.value",True), dict): # generated from line 10, col 4
                write(u'''\t\t\t\t''')
                _v = VFFSL(SL,"display_node",False)(VFFSL(SL,"entry.value",True)) # u'$display_node($entry.value)' on line 11, col 5
                if _v is not None: write(_filter(_v, rawExpr=u'$display_node($entry.value)')) # from line 11, col 5.
                write(u'''
''')
            else: # generated from line 12, col 4
                write(u'''\t\t\t\t<div class="message_details_entry">
\t\t\t\t\t<div class="message_details_entry_name">''')
                _v = VFFSL(SL,"entry.name",True) # u'$entry.name' on line 14, col 46
                if _v is not None: write(_filter(_v, rawExpr=u'$entry.name')) # from line 14, col 46.
                write(u'''</div>
\t\t\t\t\t<div class="message_details_entry_value">''')
                _v = VFFSL(SL,"entry.value",True) # u'$entry.value' on line 15, col 47
                if _v is not None: write(_filter(_v, rawExpr=u'$entry.value')) # from line 15, col 47.
                write(u'''</div>
\t\t\t\t</div>
''')
        write(u'''\t</div>
</div>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 3, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''
''')
        _v = VFFSL(SL,"display_node",False)(VFFSL(SL,"node",True)) # u'$display_node($node)' on line 23, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'$display_node($node)')) # from line 23, col 1.
        write(u'''

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''
''')
        self.main_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_MessageDetails= 'writeBody'

## END CLASS DEFINITION

if not hasattr(MessageDetails, '_initCheetahAttributes'):
    templateAPIClass = getattr(MessageDetails, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(MessageDetails)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=MessageDetails()).run()


