#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.ClassicLayout import ClassicLayout

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1361120743.396676
__CHEETAH_genTimestamp__ = 'Sun Feb 17 17:05:43 2013'
__CHEETAH_src__ = 'prewikka/templates/Stats.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Feb 23 16:14:18 2010'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class Stats(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(Stats, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def head_extra_content(self, **KWS):



        ## CHEETAH: generated from #block head_extra_content at line 3, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''<script type="text/javascript">

''')
        fcnt = 0
        for chart in VFFSL(SL,"charts",True): # generated from line 7, col 1
            write(u'''        var chart_''')
            _v = VFFSL(SL,"fcnt",True) # u'${fcnt}' on line 8, col 19
            if _v is not None: write(_filter(_v, rawExpr=u'${fcnt}')) # from line 8, col 19.
            write(u''' = null;
''')
            fcnt += 1
        write(u'''
function changeLinkUnit(unit) {
        var str = "&timeline_type=" + unit;

        if ( unit == "custom" ) {
                $("input[type=text]").each(function() {
                        str += "&" + $(this).attr("name") + "=" + $(this).attr("value");
                });
        }

        $("#topmenu").find("div.topmenu_item_active a, div.topmenu_item_inactive a").each(function() {
                $(this).attr("href", $(this).attr("href") + str);
        });
}


$(document).ready(function() {
        $("select[name=timeline_type]").change(function() {
                if ( $("select[name=timeline_type] option:selected").attr("value") == "custom" )
                        $("input[type=text]").each(function() { $(this).removeAttr("disabled") });
                else
                        $("input[type=text]").each(function() { $(this).attr("disabled", "disabled") });
        });

        changeLinkUnit($("select[name=timeline_type] option:selected").attr("value"));
});

</script>

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def gen_std(self, chart, map_index, **KWS):



        ## CHEETAH: generated from #def gen_std($chart, $map_index) at line 43, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''<fieldset>
<legend>''')
        _v = VFFSL(SL,"chart.title",True) # u'$chart.title' on line 45, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$chart.title')) # from line 45, col 9.
        write(u'''</legend>

<table width="100%">
 <tr>
  <td style="vertical-align: top;">

''')
        _orig_filter_66725615 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''   <img style="padding-top: 2px;" src=\'''')
        _v = VFN(VFFSL(SL,"chart.chart",True),"getHref",False)() # u'$chart.chart.getHref()' on line 52, col 40
        if _v is not None: write(_filter(_v, rawExpr=u'$chart.chart.getHref()')) # from line 52, col 40.
        write(u'''\' alt="Chart"/>
  </td>
 </tr>
</table>
</fieldset>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_66725615
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 62, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_90165914 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        fcnt = 0
        map_index = 0;
        write(u'''
<h2>''')
        _v = VFFSL(SL,"period",True) # u'$period' on line 67, col 5
        if _v is not None: write(_filter(_v, rawExpr=u'$period')) # from line 67, col 5.
        write(u'''</h2>

''')
        if VFFSL(SL,"current_filter",True): # generated from line 69, col 1
            write(u'''<h2>Filter: ''')
            _v = VFFSL(SL,"current_filter",True) # u'$current_filter' on line 70, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'$current_filter')) # from line 70, col 13.
            write(u'''</h2>
''')
        write(u'''
<br/><br/>

<table style="width: 100%;">
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_90165914
        write(u'''
''')
        for chart in VFFSL(SL,"charts",True): # generated from line 78, col 1
            write(u''' <tr><td id="td_''')
            _v = VFFSL(SL,"fcnt",True) # u'$fcnt' on line 79, col 17
            if _v is not None: write(_filter(_v, rawExpr=u'$fcnt')) # from line 79, col 17.
            write(u'''">
        ''')
            _v = VFFSL(SL,"gen_std",False)(VFFSL(SL,"chart",True), VFFSL(SL,"map_index",True)) # u'$gen_std($chart, $map_index)' on line 80, col 9
            if _v is not None: write(_filter(_v, rawExpr=u'$gen_std($chart, $map_index)')) # from line 80, col 9.
            write(u'''
<br/><br/>
 </td></tr>

''')
            fcnt = VFFSL(SL,"fcnt",True) + 1
            map_index += 1
        write(u'''
</table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def layout_start_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_start_hook at line 94, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''<form action="?" method="get">
''')
        for name, value in VFFSL(SL,"hidden_parameters",True): # generated from line 96, col 1
            write(u'''  <input type="hidden" name="''')
            _v = VFFSL(SL,"name",True) # u'$name' on line 97, col 30
            if _v is not None: write(_filter(_v, rawExpr=u'$name')) # from line 97, col 30.
            write(u'''" value="''')
            _v = VFFSL(SL,"value",True) # u'$value' on line 97, col 44
            if _v is not None: write(_filter(_v, rawExpr=u'$value')) # from line 97, col 44.
            write(u'''"/>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def layout_end_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_end_hook at line 102, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''</form>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def menu_extra_content(self, **KWS):



        ## CHEETAH: generated from #block menu_extra_content at line 107, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_85273737 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
<table id="timeline">
  <tr>
    <th>''')
        if False:
            _("Filter:")
        _v = VFFSL(SL,"_",False)("Filter:") # u'$_("Filter:")' on line 112, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Filter:")')) # from line 112, col 9.
        write(u'''</th>
    <td colspan="2">
     <select name="filter" class="filter_control_select">
          <option value="">&nbsp;</option>
''')
        for fltr in VFFSL(SL,"filters",True): # generated from line 116, col 9
            if VFFSL(SL,"fltr",True) == VFFSL(SL,"current_filter",True): # generated from line 117, col 11
                selected = "selected=\"selected\""
            else: # generated from line 119, col 11
                selected = ""
            write(u'''          <option value="''')
            _v = VFFSL(SL,"fltr",True) # u'$fltr' on line 122, col 26
            if _v is not None: write(_filter(_v, rawExpr=u'$fltr')) # from line 122, col 26.
            write(u'''" ''')
            _v = VFFSL(SL,"selected",True) # u'$selected' on line 122, col 33
            if _v is not None: write(_filter(_v, rawExpr=u'$selected')) # from line 122, col 33.
            write(u'''>''')
            _v = VFFSL(SL,"fltr",True) # u'$fltr' on line 122, col 43
            if _v is not None: write(_filter(_v, rawExpr=u'$fltr')) # from line 122, col 43.
            write(u'''</option>
''')
        write(u'''     </select>
    </td>
  </tr>
  <tr>
    <th>''')
        if False:
            _("Time:")
        _v = VFFSL(SL,"_",False)("Time:") # u'$_("Time:")' on line 128, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Time:")')) # from line 128, col 9.
        write(u'''</th>
    <td colspan="2">
      <select name="timeline_type">
        <option value="hour" ''')
        _v = VFFSL(SL,"timeline_hour_selected",True) # u'$timeline_hour_selected' on line 131, col 30
        if _v is not None: write(_filter(_v, rawExpr=u'$timeline_hour_selected')) # from line 131, col 30.
        write(u'''>''')
        if False:
            _("Hour")
        _v = VFFSL(SL,"_",False)("Hour") # u'$_("Hour")' on line 131, col 54
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Hour")')) # from line 131, col 54.
        write(u'''</option>
        <option value="day" ''')
        _v = VFFSL(SL,"timeline_day_selected",True) # u'$timeline_day_selected' on line 132, col 29
        if _v is not None: write(_filter(_v, rawExpr=u'$timeline_day_selected')) # from line 132, col 29.
        write(u'''>''')
        if False:
            _("Day")
        _v = VFFSL(SL,"_",False)("Day") # u'$_("Day")' on line 132, col 52
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Day")')) # from line 132, col 52.
        write(u'''</option>
        <option value="month" ''')
        _v = VFFSL(SL,"timeline_month_selected",True) # u'$timeline_month_selected' on line 133, col 31
        if _v is not None: write(_filter(_v, rawExpr=u'$timeline_month_selected')) # from line 133, col 31.
        write(u'''>''')
        if False:
            _("Month")
        _v = VFFSL(SL,"_",False)("Month") # u'$_("Month")' on line 133, col 56
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Month")')) # from line 133, col 56.
        write(u'''</option>
        <option value="custom" ''')
        _v = VFFSL(SL,"timeline_custom_selected",True) # u'$timeline_custom_selected' on line 134, col 32
        if _v is not None: write(_filter(_v, rawExpr=u'$timeline_custom_selected')) # from line 134, col 32.
        write(u'''>''')
        if False:
            _("Custom")
        _v = VFFSL(SL,"_",False)("Custom") # u'$_("Custom")' on line 134, col 58
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Custom")')) # from line 134, col 58.
        write(u'''</option>
      </select>
    </td>
  </tr>
  <tr>
    <th>''')
        if False:
            _("From:")
        _v = VFFSL(SL,"_",False)("From:") # u'$_("From:")' on line 139, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("From:")')) # from line 139, col 9.
        write(u'''</th>
    <td colspan="2"><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 140, col 40
            write(u''' disabled="disabled" ''')
        write(u'''  size="4" name="from_year" value="''')
        _v = VFFSL(SL,"from_year",True) # u'$from_year' on line 140, col 138
        if _v is not None: write(_filter(_v, rawExpr=u'$from_year')) # from line 140, col 138.
        write(u'''"/><b>/</b><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 140, col 178
            write(u''' disabled="disabled" ''')
        write(u''' size="2" name="from_month" value="''')
        _v = VFFSL(SL,"from_month",True) # u'$from_month' on line 140, col 276
        if _v is not None: write(_filter(_v, rawExpr=u'$from_month')) # from line 140, col 276.
        write(u'''"/><b>/</b><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 140, col 317
            write(u''' disabled="disabled" ''')
        write(u'''  size="2" name="from_day" value="''')
        _v = VFFSL(SL,"from_day",True) # u'$from_day' on line 140, col 414
        if _v is not None: write(_filter(_v, rawExpr=u'$from_day')) # from line 140, col 414.
        write(u'''"/></td>
  </tr>
  <tr>
    <th></th>
    <td colspan="2"><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 144, col 40
            write(u''' disabled="disabled" ''')
        write(u''' size="2" name="from_hour" value="''')
        _v = VFFSL(SL,"from_hour",True) # u'$from_hour' on line 144, col 137
        if _v is not None: write(_filter(_v, rawExpr=u'$from_hour')) # from line 144, col 137.
        write(u'''"/><b>:</b><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 144, col 177
            write(u''' disabled="disabled" ''')
        write(u''' size="2" name="from_min" value="''')
        _v = VFFSL(SL,"from_min",True) # u'$from_min' on line 144, col 273
        if _v is not None: write(_filter(_v, rawExpr=u'$from_min')) # from line 144, col 273.
        write(u'''"/></td>
  </tr>
  <tr>
    <th>''')
        if False:
            _("To:")
        _v = VFFSL(SL,"_",False)("To:") # u'$_("To:")' on line 147, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("To:")')) # from line 147, col 9.
        write(u'''</th>
    <td colspan="2"><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 148, col 40
            write(u''' disabled="disabled" ''')
        write(u''' size="4" name="to_year" value="''')
        _v = VFFSL(SL,"to_year",True) # u'$to_year' on line 148, col 135
        if _v is not None: write(_filter(_v, rawExpr=u'$to_year')) # from line 148, col 135.
        write(u'''"/><b>/</b><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 148, col 173
            write(u''' disabled="disabled" ''')
        write(u''' size="2" name="to_month" value="''')
        _v = VFFSL(SL,"to_month",True) # u'$to_month' on line 148, col 269
        if _v is not None: write(_filter(_v, rawExpr=u'$to_month')) # from line 148, col 269.
        write(u'''"/><b>/</b><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 148, col 308
            write(u''' disabled="disabled" ''')
        write(u''' size="2" name="to_day" value="''')
        _v = VFFSL(SL,"to_day",True) # u'$to_day' on line 148, col 402
        if _v is not None: write(_filter(_v, rawExpr=u'$to_day')) # from line 148, col 402.
        write(u'''"/></td>
  </tr>
  <tr>
    <th></th>
    <td colspan="2"><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 152, col 40
            write(u''' disabled="disabled" ''')
        write(u''' size="2" name="to_hour" value="''')
        _v = VFFSL(SL,"to_hour",True) # u'$to_hour' on line 152, col 135
        if _v is not None: write(_filter(_v, rawExpr=u'$to_hour')) # from line 152, col 135.
        write(u'''"/><b>:</b><input type="text" ''')
        if not VFFSL(SL,"timeline_custom_selected",True): # generated from line 152, col 173
            write(u''' disabled="disabled" ''')
        write(u''' size="2" name="to_min" value="''')
        _v = VFFSL(SL,"to_min",True) # u'$to_min' on line 152, col 267
        if _v is not None: write(_filter(_v, rawExpr=u'$to_min')) # from line 152, col 267.
        write(u'''"/></td>
  </tr>

<tr>
 <td colspan="3" style="text-align: center">

<br style="line-height: 5px;" />

<div>
 <input id="form_apply" type="submit" name="apply" value="''')
        if False:
            _("Apply")
        _v = VFFSL(SL,"_",False)("Apply") # u'$_("Apply")' on line 161, col 59
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Apply")')) # from line 161, col 59.
        write(u'''" />&nbsp;<input type="submit" name="_save" value="''')
        if False:
            _("Save")
        _v = VFFSL(SL,"_",False)("Save") # u'$_("Save")' on line 161, col 121
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Save")')) # from line 161, col 121.
        write(u'''" />
</div>

</table>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_85273737
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''
''')
        self.head_extra_content(trans=trans)
        write(u'''




''')
        self.main_content(trans=trans)
        write(u'''







''')
        self.menu_extra_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_Stats= 'writeBody'

## END CLASS DEFINITION

if not hasattr(Stats, '_initCheetahAttributes'):
    templateAPIClass = getattr(Stats, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(Stats)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=Stats()).run()


