#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1361120743.887926
__CHEETAH_genTimestamp__ = 'Sun Feb 17 17:05:43 2013'
__CHEETAH_src__ = 'prewikka/templates/utils.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Feb 23 16:14:18 2010'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class utils(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(utils, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def display_analyzer(self, analyzer, **KWS):



        ## CHEETAH: generated from #def display_analyzer(analyzer) at line 1, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''  <table>
    <thead>
      <tr>
        <td>Name</td>
        <td>Type</td>
        <td>OS</td>
        <td>Node Name</td>
        <td>Node Location</td>
        <td>Node Address</td>
      </tr>
    </thead>
    <tbody>
      <tr class="table_row_even">
        <td>''')
        _v = VFFSL(SL,"analyzer.name",True) or "n/a"
        if _v is not None: write(_filter(_v))
        write(u'''</td>
        <td>
''')
        if VFFSL(SL,"analyzer.model",True): # generated from line 17, col 11
            write(u'''            ''')
            _v = VFFSL(SL,"analyzer.model",True) # u'$analyzer.model' on line 18, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'$analyzer.model')) # from line 18, col 13.
            write(u'''
''')
            if VFFSL(SL,"analyzer.version",True): # generated from line 19, col 13
                write(u'''              ''')
                _v = VFFSL(SL,"analyzer.version",True) # u'$analyzer.version' on line 20, col 15
                if _v is not None: write(_filter(_v, rawExpr=u'$analyzer.version')) # from line 20, col 15.
                write(u'''
''')
        else: # generated from line 22, col 11
            write(u'''            n/a
''')
        write(u'''        </td>
        <td>
''')
        if VFFSL(SL,"analyzer.ostype",True): # generated from line 27, col 11
            write(u'''            ''')
            _v = VFFSL(SL,"analyzer.ostype",True) # u'$analyzer.ostype' on line 28, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'$analyzer.ostype')) # from line 28, col 13.
            write(u'''
''')
            if VFFSL(SL,"analyzer.osversion",True): # generated from line 29, col 13
                write(u'''              ''')
                _v = VFFSL(SL,"analyzer.osversion",True) # u'$analyzer.osversion' on line 30, col 15
                if _v is not None: write(_filter(_v, rawExpr=u'$analyzer.osversion')) # from line 30, col 15.
                write(u'''
''')
        else: # generated from line 32, col 11
            write(u'''            n/a
''')
        write(u'''        </td>
        <td>''')
        _v = VFFSL(SL,"analyzer.node_name",True) or "n/a"
        if _v is not None: write(_filter(_v))
        write(u'''</td>
        <td>''')
        _v = VFFSL(SL,"analyzer.node_location",True) or "n/a"
        if _v is not None: write(_filter(_v))
        write(u'''</td>
        <td>
''')
        if len(VFFSL(SL,"analyzer.node_addresses",True)) > 0: # generated from line 39, col 11
            for address in VFFSL(SL,"analyzer.node_addresses",True): # generated from line 40, col 13
                write(u'''              ''')
                _v = VFFSL(SL,"address",True) # u'$address' on line 41, col 15
                if _v is not None: write(_filter(_v, rawExpr=u'$address')) # from line 41, col 15.
                write(u'''<br/>
''')
        else: # generated from line 43, col 11
            write(u'''            n/a
''')
        write(u'''        </td>
      </tr>
    </tbody>
  </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_utils= 'respond'

## END CLASS DEFINITION

if not hasattr(utils, '_initCheetahAttributes'):
    templateAPIClass = getattr(utils, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(utils)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=utils()).run()


